drop view product_v;
drop table product;
drop table kind;
drop table maker;
drop table color;

create table color(
	id integer primary key check(id > 0),
	name text not null
);
create table maker(
	id integer primary key check(id > 0),
	name text not null
);
create table kind(
	id integer primary key check(id > 0),
	mid integer references maker(id),
	name text not null
);
create table product(
	id integer primary key check(id between 1000 and 9999),
	kid integer references kind(id),
	cid integer references color(id)
);
create view product_v as
	select
		p.id,
		k.mid, m.name as mname,
		p.kid, k.name as kname,
		p.cid, c.name as cname
	from
		product as p
		join kind as k on k.id = p.kid
		join maker as m on m.id = k.mid
		join color as c on c.id = p.cid
	order by id
;
