drop view number_v;
drop table number;
drop table goods;
drop table store;
create table store(
	id integer primary key check(id >= 0),
	name text not null
);
create table goods(
	id integer primary key check(id between 1000 and 9999),
	cost integer not null check(cost >= 0),
	price integer not null check(price >=0),
	name text not null,
	check(price > cost)
);
create table number(
	sid integer references store(id),
	gid integer references goods(id),
	num integer check(num > 0),
	primary key (sid, gid)
);
create view number_v as
	select s.id as sid, s.name as sname, g.id as gid, g.name as gname, n.num as number
		from store as s cross join goods as g
			left join number as n on (n.sid, n.gid) = (s.id, g.id)
		order by gid, sid
;
